package com.fxy.detection;

import android.annotation.SuppressLint;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.support.v7.widget.RecyclerView;
import android.text.Editable;
import android.text.TextWatcher;
import android.view.KeyEvent;
import android.view.View;
import android.view.inputmethod.EditorInfo;
import android.widget.EditText;
import android.widget.ImageButton;
import android.widget.LinearLayout;
import android.widget.TextView;
import android.widget.Toast;

import com.elvishew.xlog.XLog;
import com.fxy.R;
import com.fxy.baselibrary.base.BaseActivity;
import com.fxy.baselibrary.bean.BaseEventBusBean;
import com.fxy.baselibrary.interfaces.OnRxScanerListener;
import com.fxy.baselibrary.qrcode.ActivityScanerCode;
import com.fxy.baselibrary.util.JsonUtil;
import com.fxy.bean.ActionBean;
import com.fxy.bean.ScanBean;
import com.fxy.common.AsyncUpload;
import com.fxy.common.PictureSelectorUpload;
import com.fxy.constant.BaseConfig;
import com.fxy.constant.EventCode;
import com.fxy.net.MyDialogCallback;
import com.fxy.net.Urls;
import com.fxy.view.FloatingImageView;
import com.google.gson.Gson;
import com.google.zxing.Result;
import com.luck.picture.lib.config.PictureConfig;
import com.luck.picture.lib.entity.LocalMedia;
import com.lzy.okgo.OkGo;
import com.lzy.okgo.model.Response;

import org.json.JSONException;
import org.json.JSONObject;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import butterknife.BindView;
import butterknife.ButterKnife;
import butterknife.OnClick;
import butterknife.Unbinder;
import sto.android.app.StoJNI;
import sto.android.app.StoPdaKeyEvent;
import sto.android.app.StoTongJNI;

public class DetectionPutInMainActivity extends  BaseActivity implements StoJNI.ScanCallBack{

    /**
     * 列表适配器
     */
    Context mContext = this;

    @BindView(R.id.et_order_number)
    EditText etOrderNumber;



    @BindView(R.id.et_tracking_number)
    EditText etTrackingNumber;




    @BindView(R.id.ll_label_picture)
    LinearLayout llLabelPicture;


    @BindView(R.id.ll_weigh_picture)
    LinearLayout llWeighPicture;

    @BindView(R.id.ll_result)
    LinearLayout llResult;

    @BindView(R.id.tv_result)
    TextView tvResult;

    @BindView(R.id.ll_await_num)
    LinearLayout llAwaitNum;

    @BindView(R.id.tv_await_num)
    TextView tvAwaitNum;


    private HashMap<String, Object> postData  = new HashMap<>();


    private AsyncUpload labelPictureSelectorUpload;
    private AsyncUpload weighPictureSelectorUpload;
    private String currentPictureType= "";
    //
    //扫码扫码动作
    private ScanBean scanBean;


    private boolean showWeightImg = false;

    private boolean isRequiredShow = false;
    protected String action;


    private Unbinder unbinder;

    private JSONObject postParam = new JSONObject();


    @Override
    public int getContentViewResId() {
        return R.layout.activity_fxy_detection_putin;
    }

    @Override
    public boolean showToolBar() {
        return true;
    }

    @Override
    public boolean openEventBus() {
        return true;
    }

    @Override
    protected void getBundleExtras(Bundle bundle) {
        //XLog.e("接收数据解析：",bundle);
    }



    //finish的返回监听
    //这里的requestCode参数，就是上面设置的 1 ，当跳转的页面返回的时候，通过这个加以判断
    //resultCode ,这个参数是在跳转的页面里面规定的，它也是一个int类型的标志
    //第三个参数包含了返回的值
    //如果不需要所跳转的页面返回值，也就不需要这个方法了
    @Override
    public void onActivityResult(int requestCode, int resultCode, Intent data) {
        super.onActivityResult(requestCode, resultCode, data);

        if (resultCode == RESULT_OK) {
            // 图片选择结果回调
            if (requestCode == PictureConfig.CHOOSE_REQUEST) {
                if (currentPictureType.equals("weight_img")){
                    weighPictureSelectorUpload.setNotifyParam(getNotifyParam());
                    weighPictureSelectorUpload.getSelectImg(data);
                }else {
                    labelPictureSelectorUpload.setNotifyParam(getNotifyParam());
                    labelPictureSelectorUpload.getSelectImg(data);
                }
                totalAwaitNum();
            }
        }
    }

    /**
     * EventBus接收信息的方法，开启后才会调用(非粘性事件)
     *
     * @param event
     */
    @Override
    protected void EventBean(BaseEventBusBean event) {
//        XLog.e("----------接收返回--------------");
//        XLog.e("接收返回："+event.getEventCode());
        if (event != null && event.getEventCode() == EventCode.displacement_refresh){

        }
    }

    @Override
    public boolean isPlayMusic() {
        return true;
    }


    @Override
    protected void initView() {
        unbinder = ButterKnife.bind(this);
        setTitleName("单箱入库");

        initEdit();
        iniData();
        RecyclerView rvLabelShowImg = (RecyclerView)llLabelPicture.findViewById(R.id.rv_show_img);
        RecyclerView rvWeighShowImg = (RecyclerView)llWeighPicture.findViewById(R.id.rv_show_img);
        labelPictureSelectorUpload  = setItemPicture("label_img",rvLabelShowImg);
        weighPictureSelectorUpload  = setItemPicture("weight_img",rvWeighShowImg);

        iniPhoto();
    }



    /**
     * 设置多个上传文件
     * @param uploadType String
     * @param showImg RecyclerView
     */
    private AsyncUpload setItemPicture(String uploadType,RecyclerView showImg){

        String notifyUrl = Urls.getServiceAddress(this) + Urls.FXY_DETECTION_PUTIN;
        AsyncUpload pictureUpload = new AsyncUpload(DetectionPutInMainActivity.this,showImg,"detection",uploadType,notifyUrl);
        pictureUpload.setUploadType(uploadType);
        pictureUpload.setCompress(true,100,100);
        pictureUpload.setOnlyCamera(true);
        pictureUpload.setMaxSelectNum(9);
        pictureUpload.asyncUpload();//
        //showImg.onTouchEvent()

        pictureUpload.setOnChangeListener(new AsyncUpload.UploadChangeListener() {
            @Override
            public void uploadResult(boolean State,String actionType) {
                if (State) {
                    totalAwaitNum();
                }
            }

            @Override
            public void uploadFileKey(String fileKey) {
                System.out.println("fileKey："+fileKey);
                currentPictureType = fileKey;
            }
        });
        return  pictureUpload;
    }


    @Override
    public boolean dispatchKeyEvent(KeyEvent event) {
        //XLog.e("event:"+event.getKeyCode());
        if ((event.getKeyCode()==KeyEvent.KEYCODE_DPAD_CENTER || event.getKeyCode()==KeyEvent.KEYCODE_ENTER )  && event.getAction() == KeyEvent.ACTION_DOWN){
            //按确定键

        }
        return super.dispatchKeyEvent(event);
    }

    public HashMap<String, Object> getNotifyParam(){
        postData.put("box_number",etOrderNumber.getText().toString().trim());
        postData.put("tracking_number",etTrackingNumber.getText().toString().trim());
        labelPictureSelectorUpload.setNotifyParam(postData);
        weighPictureSelectorUpload.setNotifyParam(postData);
        return postData;
    }

    //监听按键
    public boolean onKeyDown(int keyCode, KeyEvent event) {
        XLog.e("监听按键："+keyCode);XLog.e(event);
        if (scanBean.getIsBroadcast()==0 && StoTongJNI.getIns(mContext).getEventFuction(keyCode)  == StoPdaKeyEvent.KEYCODE_SCAN
                && event.getRepeatCount() == 0) {

            if (StoTongJNI.getIns(mContext).GetScannerIsScanning()) {
//
            } else {
                StoTongJNI.getIns(mContext).SetScannerStart();
            }
        }
        return super.onKeyDown(keyCode, event);
    }

    @SuppressLint("HandlerLeak")
    Handler scanHandler = new Handler() {

        @Override
        public void handleMessage(Message msg) {
            // TODO Auto-generated method stub
            if (msg.obj != null) {

                String scanResult = msg.obj.toString().trim();
                if (!scanResult.isEmpty()){
                    setScanResult(scanResult);
                }
            }

        }

    };
    @Override
    public void onScanResults(String str) {
        Message msg = new Message();
        msg.obj = str;
        scanHandler.sendMessage(msg);


    }


    @Override
    public void onScanResults(String str, int type) {

    }
    /**
     * 定义广播接受
     */
    BroadcastReceiver mReceiver = new BroadcastReceiver() {
        @Override
        public void onReceive(Context context, Intent intent) {
            String scanResult = intent.getStringExtra(scanBean.getDataName());
            if (scanResult==null){return; }
            String scanStatus = "";
            if (!scanBean.getStatusName().isEmpty()){
                scanStatus = intent.getStringExtra(scanBean.getStatusName());
            }else{
                scanStatus = scanResult.isEmpty()? "" : "ok"; //有值 默认是扫码成功;
            }

            //新大陆(MT65,MT90) 需要手动关闭
            if (!scanBean.getActionStop().isEmpty()){
                Intent stopIntent = new Intent(scanBean.getActionStop());
                mContext.sendBroadcast(stopIntent);
            }

            if ("ok".equals(scanStatus)){
                setScanResult(scanResult);
            }else{
                showErrorToast(getString(R.string.scan_failed));
            }
        }
    };

    /**
     * 注册广播
     */
    private void initReceiver(){

        try {

            String scanStr = getScanSetting();
            scanBean = JsonUtil.getObject(scanStr, ScanBean.class);
            Integer is_broadcast = scanBean.getIsBroadcast();//是否广播

            if (is_broadcast ==1){
                IntentFilter mFilter = new IntentFilter(scanBean.getAction());
                this.registerReceiver(mReceiver, mFilter);
            }else{
                //不广播进行处理 jni模式
                String pdaBrand = StoTongJNI.getmPdaBrand();
                if (!pdaBrand.isEmpty()){
                    StoTongJNI.getIns(this).setmScanCB(this);
                    StoTongJNI.getIns(this).SetScannerOn();
                }
            }


        }catch (Exception e) {
            showErrorToast("获取扫码配置失败"+e.getMessage());
            XLog.e("获取扫码配置失败:" + e.getMessage());
        }
    }

    private void initEdit() {
        List<EditText> list = new ArrayList<>();
        list.add(etTrackingNumber);
        list.add(etOrderNumber);
        unifyEdit(list);
        llResult.setVisibility(View.GONE);
        llWeighPicture.setVisibility(View.GONE);
    }


    private void iniData(){

    }

    //getAwaitNum
    private void totalAwaitNum(){
        int awaitNum = labelPictureSelectorUpload.getAwaitNum();
        tvAwaitNum.setText(String.valueOf(awaitNum));
    }

    //统一按钮回调
    public void callbackEditor(View v){
        switch (v.getId()) {
            case R.id.et_tracking_number:
                getInboundTrack();
                break;
            case R.id.et_order_number:
                if (etTrackingNumber.getText().toString().isEmpty()){
                    etTrackingNumber.requestFocus();
                    return;
                }
                if (etOrderNumber.getText().toString().isEmpty()){
                    etOrderNumber.requestFocus();
                    return;
                }

                labelPictureSelectorUpload.authCamera();
                break;
            default:
        }

    }

    /**
     * 统一设置Edit监听
     * @param  list
     */
    public void unifyEdit(List<EditText> list){
        for (int i=0;i<list.size();i++){
            EditText editText = list.get(i);

            LinearLayout linearLayout = (LinearLayout)editText.getParent();
            ImageButton imageButton = getChildImageButton(linearLayout);


            //监听按确定
            editText.setOnEditorActionListener(new TextView.OnEditorActionListener() {
                @Override
                public boolean onEditorAction(TextView v, int actionId, KeyEvent event) {
                    //XLog.e("actionId："+actionId);
                    if (actionId == EditorInfo.IME_ACTION_SEND || actionId == EditorInfo.IME_ACTION_DONE   ) {
                        if (v.getText().toString().trim().isEmpty()) {
                            setEditTextFocused(v,true);
                            showWarningToast(v.getHint().toString());
                            return false;
                        }else{
                            setEditTextNormal(v,true);
                        }

                        callbackEditor(v);

                        return false;
                    }
                    return false;
                }
            });
            editText.addTextChangedListener(new TextWatcher() {
                public void onTextChanged(CharSequence s, int start, int before, int count) {
                    EditText currentEditText = null;
                    ImageButton currentImage = null;
                    //获取焦点的view对象
                    View view=getWindow().getDecorView().findFocus();
                    //如果是EditText
                    if(view instanceof EditText){
                        currentEditText = (EditText) view;
                        currentImage = getChildImageButton((LinearLayout)currentEditText.getParent());
                    }

                    if (s.length() > 0  ) {

                        if (currentImage !=null ){
                            currentImage.setVisibility(View.VISIBLE);
                        }
                        if (currentEditText!=null){
                            setEditTextNormal(currentEditText,true);
                        }

                    } else {
                        if (currentImage !=null ){
                            currentImage.setVisibility(View.INVISIBLE);
                        }
                        if (currentEditText!=null && isRequiredShow){
                            setEditTextFocused(currentEditText,true);
                        }
                    }
                }

                public void beforeTextChanged(CharSequence s, int start, int count, int after) {
                }

                public void afterTextChanged(Editable s) {

                }
            });

            if (imageButton !=null ){
                unifyClearEdit(imageButton);
            }
        }
    }


    private OnRxScanerListener mScanerListener = new OnRxScanerListener() {
        @Override
        public void onSuccess(String type, Result result) {
            String scanResult = result.getText();
            switch (type){
                case BaseConfig.COMMON_SCANNER_ONLY:
                    setScanResult(scanResult);

                    break;
            }
        }
        @Override
        public void onFail(String type, String message) {

        }
    };

    //把扫描结果赋值
    private void setScanResult(String scanResult){
        //获取焦点的view对象
        View view=getWindow().getDecorView().findFocus();
        //如果是EditText
        if(view instanceof EditText)
        {
            ((EditText) view).setText(scanResult);
            showSuccessToast("扫描成功");
            switch (view.getId()) {
                case R.id.et_tracking_number:
                    getInboundTrack();
                    break;
                case R.id.et_order_number:
                    showSuccessToast("扫描成功");
                    break;
                default:
            }


        }
    }

    private void getInboundTrack(){


        if (etTrackingNumber.getText().toString().isEmpty()){
            showErrorToast(etTrackingNumber.getHint().toString());
            return;
        }


        Map<String,Object> math = new HashMap<>();
        math.put("tracking_number",etTrackingNumber.getText().toString().trim());


        String mathJson = (new Gson()).toJson(math);

        if (!checkRepeat(Urls.FXY_DETECTION_PUTIN_TRACK+(mathJson.toString()))){
            Toast.makeText(this, getString(R.string.error_data_processed), Toast.LENGTH_LONG).show();
            return;
        }

        OkGo.<String>post(Urls.getServiceAddress(this) + Urls.FXY_DETECTION_PUTIN_TRACK).upJson(mathJson)
                .execute(new MyDialogCallback(this, true, true) {
                    @Override
                    public void onSuccess(Response<String> response) {
                        super.onSuccess(response);
                        try {
                            ActionBean bean = JsonUtil.getObject(response.body(), ActionBean.class);
                            JSONObject result = new JSONObject();
                            if (bean.data!=null && !bean.data.isEmpty() && !bean.data.equals("[]")){
                                result = new JSONObject(bean.data);
                            }

                            String voiceName = result.has("voice_name") ? result.getString("voice_name"):"";
                            String showText = result.has("show_text") ? result.getString("show_text"):"";
                            String show_weight_img = result.has("show_weight_img") ? result.getString("show_weight_img"):"";



                            showWeightImg = show_weight_img.contains("1");
                            llWeighPicture.setVisibility(showWeightImg ? View.VISIBLE:View.GONE);
                            llResult.setVisibility(showText.isEmpty() ? View.GONE:View.VISIBLE);
                            tvResult.setText(showText);



                            if(bean.code == 1){
                                showSuccessToast(bean.msg,voiceName);
                                etOrderNumber.requestFocus();
                                etOrderNumber.setSelection(etOrderNumber.getText().toString().length());
                            }else{
                                showWarningToast(bean.msg,voiceName);
                            }
                        } catch (Exception e) {
                            e.printStackTrace();
                            XLog.e("添加开箱拆柜数据结果返回错误",e.getMessage());
                        }
                    }
                });
    }

    private void pictureInbound(){
        isRequiredShow = true;
        if (!validate()){
            return;
        }




        //假成功
        initFinish();
        showSuccessToast("success");

//        if (!checkRepeat(Urls.FXY_DETECTION_PUTIN+(postParam.toString()))){
//            Toast.makeText(this, getString(R.string.error_data_processed), Toast.LENGTH_LONG).show();
//            return;
//        }



        OkGo.<String>post(Urls.getServiceAddress(this) + Urls.FXY_DETECTION_PUTIN).upJson(postParam)
                .execute(new MyDialogCallback(this, true, false) {
                    @Override
                    public void onSuccess(Response<String> response) {
                        super.onSuccess(response);
                        try {
                            ActionBean bean = JsonUtil.getObject(response.body(), ActionBean.class);
//                            if(bean.code == 1){
//                                showSuccessToast(bean.msg);
//                            }else{
//                                showWarningToast(bean.msg);
//                            }
                        } catch (Exception e) {
                            e.printStackTrace();
                            XLog.e("添加开箱拆柜数据结果返回错误",e.getMessage());
                        }
                    }
                });
    }

    private void initFinish(){
        isRequiredShow = false;
        labelPictureSelectorUpload.emptyRemake();//清空图片
        weighPictureSelectorUpload.emptyRemake();
        etOrderNumber.setText("");
        etTrackingNumber.setText("");
        etTrackingNumber.requestFocus();
        llResult.setVisibility(View.GONE);
        llWeighPicture.setVisibility(View.GONE);
    }

    /*
     * 校验必录
     */
    private boolean validate(){


        if (etTrackingNumber.getText().toString().isEmpty()){
            showWarningToast(etTrackingNumber.getHint().toString());
            return  false;
        }

        if (etOrderNumber.getText().toString().isEmpty()){
            showWarningToast(etOrderNumber.getHint().toString());
            return  false;
        }

        try {
            postParam = new JSONObject();
            Gson gson = new Gson();

            List<LocalMedia>  labelPhotoList = labelPictureSelectorUpload.getSelectList();


            //检查是否拍照  工单处理时拍照拍照非必传
            if (labelPhotoList.size()==0){
                showWarningToast("面单照片不能为空");
                return false;
            }
            postParam.put("label_img_tag",labelPictureSelectorUpload.getUniqueTag());


            if (showWeightImg){
                List<LocalMedia> weighPhotoList = weighPictureSelectorUpload.getSelectList();
                if (weighPhotoList.size()==0){
                    showWarningToast("内件照片不能为空");
                    return false;
                }
                postParam.put("weight_img_tag",weighPictureSelectorUpload.getUniqueTag());
             }


            postParam.put("box_number",etOrderNumber.getText().toString().trim());
            postParam.put("tracking_number",etTrackingNumber.getText().toString().trim());

        } catch (JSONException e) {
            showWarningToast("系统异常"+e.getMessage());
            e.printStackTrace();
            return false;
        }
        return true;
    }

    private void iniPhoto(){
//        HashMap<String, Object> map = new HashMap<>();
//        map.put("disabled",false);
//        map.put("error","不可拍照");
//        labelPictureSelectorUpload.setLimitOperate(map);
//        weighPictureSelectorUpload.setLimitOperate(map);
    }

    //sIsGoodinfoMatch,sIsBattery,sIsMagnetic,sIsWood,sIsExtra,sIsOther
    @OnClick({R.id.btn_confirm})
    public void onViewClicked(View view) {
        Bundle bundle = new Bundle();
        switch (view.getId()) {
            case R.id.btn_confirm:
                pictureInbound();
                break;
            default:
                break;
        }
    }

    @Override
    protected void onDestroy() {
        unbinder.unbind();
        labelPictureSelectorUpload.removeHandler();
        weighPictureSelectorUpload.removeHandler();
        super.onDestroy();
    }
    @Override
    protected void onResume() {
        super.onResume();
        initReceiver();
    }
    @Override
    protected void onPause() {
        super.onPause();
        //销毁在onResume()方法中的广播
        try {
            //停止扫描
            Integer is_broadcast = scanBean.getIsBroadcast();//是否广播
            if (is_broadcast==0){
                StoTongJNI.getIns(mContext).SetScannerStop();
                StoTongJNI.getIns(mContext).SetScannerOff();
            }else{
                unregisterReceiver(mReceiver);
            }
        }catch (Exception e){
            XLog.e("销毁广播失败：",e.getMessage());
        }
    }

}
